program Berberi; { RTK 2008.3.2 }
const MaxW = 3000; MaxH = 3000;
type CelicaT = (Gor, Levo, Dol, Desno, Prazna, Pregledana, Neobiskana);
     KdoT = (Nic, Yusuf, Abu);
const DX: array [CelicaT] of integer = (0, -1, 0, 1, 0, 0, 0);
      DY: array [CelicaT] of integer = (-1, 0, 1, 0, 0, 0, 0);
var
  A: packed array [0..MaxH + 1, 0..MaxW + 1] of CelicaT;
  F: text;
  w, h, x, y, xx, yy, yKoren, xRazcep, Stopnja: integer; c: char;
  StMest: array [KdoT] of integer; d, dNasl: CelicaT; Poddrevo: KdoT; Prvic: boolean;
begin
  { Preberimo vhodne podatke. }
  if ParamCount > 0 then Assign(F, ParamStr(1)) else Assign(F, 'berberi.in');
  Reset(F); ReadLn(F, w, h);
  for x := 1 to w do begin A[0, x] := Prazna; A[h + 1, x] := Prazna end;
  for y := 1 to h do begin A[y, 0] := Prazna; A[y, w + 1] := Prazna end;
  yKoren := -1; xRazcep := -1;
  for y := 1 to h do begin
    for x := 1 to w do begin
      Read(F, c); if c = '.' then A[y, x] := Prazna else A[y, x] := Neobiskana;
      if x = 1 then if c = 'X' then yKoren := y;
    end; {for x}
    ReadLn(F);
  end; {for y}
  Close(F);
  { Preglejmo drevo. }
  StMest[Yusuf] := 0; StMest[Abu] := 0; StMest[Nic] := 0; Poddrevo := Nic;
  x := 1; y := yKoren; A[y, x] := Desno;
  while A[y, x] <> Prazna do begin
    { Doloimo stopnjo trenutne toke in poiimo kaknega
      e neobiskanega otroka. }
    Stopnja := 0; dNasl := Prazna; Prvic := true;
    for d := Gor to Desno do begin
      xx := x + DX[d]; yy := y + DY[d];
      if not (A[yy, xx] in [Pregledana, Neobiskana]) then continue;
      Stopnja := Stopnja + 1;
      if A[yy, xx] = Neobiskana then dNasl := d else Prvic := false;
    end; {for d}
    {WriteLn('x = ', x, ', y = ', y, '; d = ', Ord(dNasl), '; stopnja = ', stopnja, '; poddrevo = ', Ord(Poddrevo));}
    if Stopnja = 0 then { Smo v listu. }
      StMest[Poddrevo] := StMest[Poddrevo] + 1
    else if Stopnja > 1 then begin { Smo v razvejiu. }
      if Poddrevo = Nic then xRazcep := x { Mesto prvega spora med Yusufom in Muhammadom. }
      else if Prvic then StMest[Poddrevo] := StMest[Poddrevo] + 1;
    end; {if}
    if dNasl <> Prazna then begin { Spustimo se naprej po drevesu. }
      if (x = xRazcep) and (y = yKoren) then { Zapomnimo si, v katero poddrevo gremo zdaj. }
        if dNasl = Dol then Poddrevo := Abu 
        else Poddrevo := Yusuf;
      x := x + DX[dNasl]; y := y + DY[dNasl];
      A[y, x] := dNasl;
    end else begin { Vrnimo se nazaj v oeta trenutne toke. }
      d := A[y, x]; A[y, x] := Pregledana;
      if (x = xRazcep) and (y = yKoren) then Poddrevo := Nic;
      x := x - DX[d]; y := y - DY[d];
    end; {if}
  end; {while}
  { Izpiimo rezultat. }
  if ParamCount > 1 then Assign(F, ParamStr(2)) else Assign(F, 'berberi.out');
  Rewrite(F); WriteLn(F, StMest[Yusuf], ' ', StMest[Abu]); Close(F);
end. {Berberi}
