program ObracanjeBitov; { RTK 2008.3.5 }
const MaxMinStranica = 21; MaxStranica = 50;
type TabelaT = packed array [0..(1 shl MaxMinStranica) - 1] of integer;
var
  w, h, Stolpci, x, y, NajEnic, StEnic, NajOp, StOp, k: integer;
  a: array [0..MaxStranica - 1] of integer;
  StBitov: ^TabelaT;
  F: text; Obrni: boolean; c: char;
begin
  { Preberimo vhodne podatke. }
  if ParamCount > 0 then Assign(F, ParamStr(1)) else Assign(F, 'toggle.in');
  Reset(F); ReadLn(F, w, h);
  Obrni := (h < w); { da bo prila v eksponent kraja stranica }
  for y := 0 to w - 1 do a[y] := 0;
  for y := 0 to h - 1 do begin
    for x := 0 to w - 1 do begin
      Read(F, c); 
      if c = '#' then 
        if Obrni then a[x] := a[x] or (1 shl y)
        else a[y] := a[y] or (1 shl x);
    end; {for x}
    ReadLn(F);
  end; {for y}
  Close(F);
  if Obrni then begin y := w; w := h; h := y end;
  { Pripravimo si tabelo s tevilom priganih bitov
    za vsako w-bitno celo tevilo. }
  GetMem(StBitov, sizeof(TabelaT[0]) shl w);
  StBitov^[0] := 0;
  for y := 0 to w - 1 do 
    for x := 0 to (1 shl y) - 1 do 
      StBitov^[x or (1 shl y)] := StBitov^[x] + 1;;
  { Preizkusimo vse kombinacije stolpcev, ki bi jih lahko zatogglali. }
  NajEnic := w * h + 1; NajOp := 0;
  for Stolpci := 0 to (1 shl w) - 1 do begin
    StEnic := 0; StOp := StBitov^[Stolpci];
    for y := 0 to h - 1 do begin
      k := StBitov^[a[y] xor Stolpci];
      if k <= w - k then StEnic := StEnic + k
      else begin StOp := StOp + 1; StEnic := StEnic + w - k end;
    end; {for y}
    if StEnic < NajEnic then begin NajEnic := StEnic; NajOp := StOp end
    else if (StEnic = NajEnic) and (StOp < NajOp) then NajOp := StOp;
  end; {for Stolpci}
  { Izpiimo rezultat. }
  if ParamCount > 1 then Assign(F, ParamStr(2)) else Assign(F, 'toggle.out');
  Rewrite(F); WriteLn(F, NajEnic, ' ', NajOp); Close(F);
end. {ObracanjeBitov}
